'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (modules, stats) {
  (0, _validateStats2.default)(stats);
  var modulesValues = {};
  for (var prop in modules) {
    if (modules.hasOwnProperty(prop)) {
      modulesValues[modules[prop].name] = modules[prop];
    }
  }

  var statModules = [];
  stats.modules.forEach(function (module) {
    if (modulesValues[module.name]) {
      statModules.push(_extends({}, module, {
        key: modulesValues[module.name].key
      }));
    }
  });

  var chunks = (0, _extractModules.extractChunks)(stats, statModules);
  chunks.push.apply(chunks, _toConsumableArray((0, _extractModules.extractEntry)(stats)));

  return chunks;
};

var _validateStats = require('./utils/validateStats');

var _validateStats2 = _interopRequireDefault(_validateStats);

var _extractModules = require('./extractModules');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }