'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setAsyncRenderer = exports.registerModule = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _isNode = require('./utils/isNode');

var _isNode2 = _interopRequireDefault(_isNode);

var _callerFile = require('./utils/callerFile');

var _callerFile2 = _interopRequireDefault(_callerFile);

var _dirname = require('./utils/dirname');

var _dirname2 = _interopRequireDefault(_dirname);

var _join = require('./utils/join');

var _join2 = _interopRequireDefault(_join);

var _shallowDiff = require('./utils/shallowDiff');

var _shallowDiff2 = _interopRequireDefault(_shallowDiff);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var modules = {
  registeredModules: {},
  registeredWebpackModules: {},
  asyncRenderer: null
};

var registerModule = exports.registerModule = function registerModule(name, module) {
  modules.registeredModules[name] = module;
};

var setAsyncRenderer = exports.setAsyncRenderer = function setAsyncRenderer(asyncRenderer) {
  modules.asyncRenderer = asyncRenderer;
};

function addDefaultExtension(path) {
  if (path.match(/\.([^\/|\\])*$/)) return path;
  return path + '.js';
}

exports.default = function (name, path, systemImport) {
  systemImport = systemImport();
  if ((0, _isNode2.default)()) {
    var _ret = function () {
      var asyncRenderer = modules.asyncRenderer;
      modules.asyncRenderer = null;

      if (typeof __webpack_require__ === 'function') {
        if (asyncRenderer) {
          if (modules.registeredWebpackModules[name]) {
            asyncRenderer.addWebpackModules(name, modules.registeredWebpackModules[name]);
          } else {
            (function () {
              var currentModules = _extends({}, __webpack_require__.c);
              systemImport.then(function () {
                var newModules = (0, _shallowDiff2.default)(currentModules, _extends({}, __webpack_require__.c));
                var finalModules = {};
                for (var prop in newModules) {
                  if (newModules.hasOwnProperty(prop)) {
                    finalModules[prop] = newModules[prop];
                    break;
                  }
                }

                modules.registeredWebpackModules[name] = finalModules;
                asyncRenderer.addWebpackModules(name, finalModules);
              });
            })();
          }
        }
        return {
          v: systemImport
        };
      } else {
        path = addDefaultExtension((0, _join2.default)((0, _dirname2.default)((0, _callerFile2.default)()), path));
        if (asyncRenderer) asyncRenderer.addModule(name, path);
        return {
          v: systemImport
        };
      }
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }

  if (modules.registeredModules[name]) {
    var _ret3 = function () {
      var promise = {
        then: function then(callback) {
          return callback(modules.registeredModules[name]);
        }, // todo: try with Promise.resolve()
        catch: function _catch() {
          return promise;
        }
      };
      return {
        v: promise
      };
    }();

    if ((typeof _ret3 === 'undefined' ? 'undefined' : _typeof(_ret3)) === "object") return _ret3.v;
  }

  return systemImport;
};